- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Friends

# MPlugArray Class Reference

# OpenMaya - API module for common classes

Search for all occurrences

## Detailed Description

Array of MPlugs data type.

This class implements an array of MPlugs. Common convenience functions are available, and the implementation is compatible with the internal Maya implementation so that it can be passed efficiently between plugins and internal maya data structures.

Examples:

  affectsNode.cpp, animExportUtil.cpp, animExportUtil.h, apiMeshShape.cpp, apiMeshShape.h, cgfxAttrDef.cpp, createClipCmd.cpp, D3DViewportRenderer.cpp, dagPoseInfoCmd.cpp, exportJointClusterDataCmd.cpp, findFileTexturesCmd.cpp, findTexturesPerPolygonCmd.cpp, GLSLShaderNode.cpp, maTranslator.cpp, nodeInfoCmd.cpp, particleAttrNode.cpp, polyModifierCmd.cpp, polyWriter.cpp, ShadingConnection.cpp, and slopeShaderBehavior.cpp.

`#include <MPlugArray.h>`

List of all members.

## Public Member Functions
| MPlugArray ()
| Default constructor.
| MPlugArray (const MPlugArray &other)
| Copy Constructor.
| MPlugArray (unsigned int initializeSize, const MPlug &initialValue)
| Create a new array of MPlugs of a specified size and initialize all the elements with the given initial value.
| ~MPlugArray ()
| Class Destructor.
const MPlug & | operator[] (unsigned int index) const
| Index operator.
MPlugArray & | operator= (const MPlugArray &other)
| Assignment operator copies all of the elements of the other array into this one.
MStatus | set (const MPlug &element, unsigned int index)
| Sets the value of the indicated element to the indicated MPlug value.
MStatus | setLength (unsigned int length)
| Set the length of the array.
unsigned int | length () const
| Returns the number of elements in the instance.
MStatus | remove (unsigned int index)
| Remove the array element at the given index.
MStatus | insert (const MPlug &element, unsigned int index)
| Inserts a new value into the array at the given index.
MStatus | append (const MPlug &element)
| Adds a new element to the end of the array.
MStatus | copy (const MPlugArray &source)
| Copy the contents of the source array to this array.
MStatus | clear ()
| Clear the contents of the array.
void | setSizeIncrement (unsigned int newIncrement)
| Set the size by which the array will be expanded whenever expansion is necessary.
unsigned int | sizeIncrement () const
| Return the size by which the array will be expanded whenever expansion is necessary.
| MPlugArray (const MPlug src[], unsigned int count)
| NO SCRIPT SUPPORT.
MStatus | get (MPlug dest[]) const
| NO SCRIPT SUPPORT.
MPlug & | operator[] (unsigned int index)
| NO SCRIPT SUPPORT.
## Static Public Member Functions
static const char * | className ()
| Returns the name of this class.
## Friends
class | MPlug Search for all occurrences

## Constructor & Destructor Documentation

MPlugArray | ( |  | ) |

Default constructor.

The instance is set to contain no elements.

MPlugArray | ( | const MPlugArray & | other | ) |

Copy Constructor.

Parameters:

  [in] | other | the array with which to initialize this instance

MPlugArray | ( | unsigned int | initialSize,
|  | const MPlug & | initialValue
| ) |  |

Create a new array of MPlugs of a specified size and initialize all the elements with the given initial value.

Parameters:

  [in] | initialSize | the initial size of the array
  [in] | initialValue | the initial value of each element

MPlugArray | ( | const MPlug | src[],
|  | unsigned int | count
| ) |  |

NO SCRIPT SUPPORT.

Create a new array of MPlugs and initialize it with the given MPlugs elements.

Parameters:

  [in] | src | an array of MPlugs
  [in] | count | the number of elements in the src array

## Member Function Documentation

const MPlug & operator[] | ( | unsigned int | index | ) | const

Index operator.

Returns the value of the element at the given index. No range checking is done - valid indices are 0 to length()-1.

Parameters:

  [in] | index | the index of the desired element

Returns:
  The value of the indicated element

MPlugArray & operator= | ( | const MPlugArray & | other | ) |

Assignment operator copies all of the elements of the other array into this one.

If the other array was returned as a reference to internal data then this array will also become a reference rather than doing a full copy.

Parameters:

  [in] | other | the array being copied

Returns:
  A reference to this array

MStatus set | ( | const MPlug & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Sets the value of the indicated element to the indicated MPlug value.

Parameters:

  [in] | element | the new value for the indicated element
  [in] | index | the index of the element that is to be set to the the new value

Returns:
  MS::kSuccess if the value was set successfully and MS::kFailure otherwise

MStatus setLength | ( | unsigned int | length | ) |

Search for all occurrences

Set the length of the array.

This will grow and shrink the array as desired. Elements that are grown have uninitialized values, while those which are shrunk will lose the data contained in the deleted elements (ie. it will release the memory).

Parameters:

  [in] | length | the new size of the array

unsigned int length | ( |  | ) | const

Search for all occurrences

Returns the number of elements in the instance.

Returns:
  The number of elements in the instance

Examples:
  animExportUtil.cpp, cgfxAttrDef.cpp, createClipCmd.cpp, D3DViewportRenderer.cpp, dagPoseInfoCmd.cpp, findFileTexturesCmd.cpp, findTexturesPerPolygonCmd.cpp, GLSLShaderNode.cpp, maTranslator.cpp, nodeInfoCmd.cpp, particleAttrNode.cpp, polyModifierCmd.cpp, polyWriter.cpp, ShadingConnection.cpp, and slopeShaderBehavior.cpp.

MStatus remove | ( | unsigned int | index | ) |

Search for all occurrences

Remove the array element at the given index.

All array elements following the removed element are shifted toward the first element.

Parameters:

  [in] | index | index of the element to be removed

Returns:
  MS::kSuccess if the remove was successful and MS::kFailure otherwise

MStatus insert | ( | const MPlug & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Inserts a new value into the array at the given index.

The initial element at that index, and all following elements, are shifted towards the last. If the array cannot be expanded in size by 1 element, then the insert will fail and the existing array will remain unchanged.

Parameters:

  [in] | element | the new value to insert into the array
  [in] | index | the index of the element to set to the the new value

Returns:
  MS::kSuccess if the insert was successful and MS::kFailure otherwise

MStatus append | ( | const MPlug & | element | ) |

Search for all occurrences

Adds a new element to the end of the array.

If the array cannot be expanded in size by 1 element, then the append will fail and the existing array will remain unchanged.

Parameters:

  [in] | element | the value for the new last element

Returns:
  MS::kSuccess if the append was successful and MS::kFailure otherwise

Examples:
  affectsNode.cpp, and polyModifierCmd.cpp.

MStatus copy | ( | const MPlugArray & | source | ) |

Search for all occurrences

Copy the contents of the source array to this array.

Parameters:

  [in] | source | array to copy from

Returns:
  MS::kSuccess if the copy was successful and MS::kFailure otherwise

MStatus clear | ( |  | ) |

Search for all occurrences

Clear the contents of the array.

After this operation the length method will return 0. This does not change the amount of memory allocated to the array, only the number of valid elements in it.

Returns:
  MS::kSuccess if the operation is successful and MS::kFailure otherwise

Examples:
  polyModifierCmd.cpp.

void setSizeIncrement | ( | unsigned int | newIncrement | ) |

Search for all occurrences

Set the size by which the array will be expanded whenever expansion is necessary.

Parameters:

  [in] | newIncrement | the new increment

unsigned int sizeIncrement | ( |  | ) | const

Search for all occurrences

Return the size by which the array will be expanded whenever expansion is necessary.

Returns:
  The size increment.

MStatus get | ( | MPlug | array[] | ) | const

Search for all occurrences

NO SCRIPT SUPPORT.

Copy the elements of the array into the given array of MPlugs.

No checking is done to ensure that the destination array of MPlugs is large enough to hold all the elements of the instance.

Parameters:

  [out] | array | the array to populate

Returns:
  MS::kSuccess if the array argument is a non-zero pointer and MS::kFailure otherwise

MPlug & operator[] | ( | unsigned int | index | ) |

NO SCRIPT SUPPORT.

Index operator.

Returns the value of the element at the given index. No range checking is done - valid indices are 0 to length()-1.

Parameters:

  [in] | index | the index of the desired element

Returns:
  The value of the indicated element

const char * className | ( |  | ) | `[static]`

Search for all occurrences

Returns the name of this class.

Returns:
  The name of this class.

MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray
MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray MPlugArray